----------------------------------------------------------------------
-- WKMascot ~N}XRbg W[
----------------------------------------------------------------------

local math							= math;
local setmetatable                  = setmetatable;
local cpp_NewMascot                 = cpp_NewMascot;
local cpp_MascotChangeState         = cpp_MascotChangeState;
local cpp_MascotChangeChildState    = cpp_MascotChangeChildState;
local cpp_MascotSetPos              = cpp_MascotSetPos;
local cpp_MascotGetPos              = cpp_MascotGetPos;
local cpp_MascotSetDir              = cpp_MascotSetDir;
local cpp_MascotGetDir              = cpp_MascotGetDir;
local cpp_MascotSetMotion           = cpp_MascotSetMotion;
local cpp_MascotSetCallback_Loop    = cpp_MascotSetCallback_Loop;
local cpp_MascotSetCallback_Catch   = cpp_MascotSetCallback_Catch;
local cpp_MascotSetCallback_Release = cpp_MascotSetCallback_Release;

module("MOD.Mascot.Miku");

MascotMiku = {};

--------------------------------------------------
--IvV
--------------------------------------------------

--[VXg
local motion_list = {};
motion_list["stand"]  = "motion/miku_motion_stand.dae";
motion_list["walk"]   = "motion/miku_motion_walk.dae";
motion_list["catch"]  = "motion/miku_motion_squat.dae";

--fȂ
local option = {};
option["model"]       = "model/miku.dae";	--f
option["scale"]       = 1.5;				--XP[
option["motion_list"] = motion_list;		--[VXg


--====================================================================
--CxgR[obN
--====================================================================

-------------------------------------------------
--t[
-------------------------------------------------

function MascotMiku:cb_Loop()

	if self.m_AI~=nil and self.m_AI.cb_Loop~=nil then

		self.m_AI:cb_Loop( self );

	end

end

-------------------------------------------------
--}EXhbOňړ / ͂܂ꂽƂ
-------------------------------------------------

function MascotMiku:cb_Catch()

	if self.m_AI~=nil and self.m_AI.cb_Catch~=nil then

		self.m_AI:cb_Catch( self );

	end

end

-------------------------------------------------
--}EXhbOňړ / ꂽƂ
-------------------------------------------------

function MascotMiku:cb_Release()

	if self.m_AI~=nil and self.m_AI.cb_Release~=nil then

		self.m_AI:cb_Release( self );

	end

end


--------------------------------------------------
--}XRbgNX
--------------------------------------------------

function new()

	self = {
		_handle = 0;
		m_AI    = nil;
	}

	self._handle = cpp_NewMascot( option );

	--CxgR[obNo^
	cpp_MascotSetCallback_Loop   ( self, MascotMiku.cb_Loop    );	--t[
	cpp_MascotSetCallback_Catch  ( self, MascotMiku.cb_Catch   );	--}EXhbOňړ / ͂܂ꂽƂ
	cpp_MascotSetCallback_Release( self, MascotMiku.cb_Release );	--}EXhbOňړ / ꂽƂ

	return setmetatable(self,{__index=MascotMiku});

end

--------------------------------------------------
--AIݒ
--------------------------------------------------

function MascotMiku:SetAI( ai )

	self.m_AI = ai;

	ai:Init( self );

end

--------------------------------------------------
--Xe[gύX
--------------------------------------------------

function MascotMiku:ChangeState( state )

	cpp_MascotChangeState( self, state );

end

--------------------------------------------------
--[Vݒ
--------------------------------------------------

function MascotMiku:SetMotion( motion_name )

	cpp_MascotSetMotion( self, motion_name );

end

--------------------------------------------------
--Wݒ
--------------------------------------------------

function MascotMiku:SetPos( x, y, z )

	cpp_MascotSetPos( self, x, y, z );

end

--------------------------------------------------
--W擾
--------------------------------------------------

function MascotMiku:GetPos()

	return cpp_MascotGetPos( self );

end

--------------------------------------------------
--ݒ
--------------------------------------------------

function MascotMiku:SetDir( dir, interp )

	cpp_MascotSetDir( self, dir, interp );

end

--------------------------------------------------
--擾
--------------------------------------------------

function MascotMiku:GetDir()

	return cpp_MascotGetDir( self );

end


